package ADS3kp;
use Exporter;
use Carp;

use strict;
use Net::Telnet;
use Time::HiRes qw( usleep nanosleep );
#use ADS3kp_conf;

#@ISA = qw(Exporter);

#use Time::Local;
#use Mjd;

BEGIN{
}
sub DESTROY($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    $telnet->close() if(defined($telnet));

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub SetHost($$$$){
    my ($pkg,$host,$usr,$pass) = @_;
    unless(defined($host) && defined($usr) && defined($pass)){
	print STDERR "E ADS3kp::SetHost(): missiong some of host,user,pass \n";
	return -1;
    }
    $pkg->{host} = $host; 
# ץץ(ɽ)    
#    my $prompt = '/cosmo login:$|Password:$|\[.+\]\$ $/';
#    my $telnet = new Net::Telnet(Timeout => 10,Prompt => $prompt);
    my $telnet = new Net::Telnet($host);
    $telnet->login($usr, $pass) ;
    $pkg->{telnet} = $telnet;
    return 0;
}

sub SigCheck(){
 my $pkg = shift;
 my $telnet = $pkg->{telnet};
 unless(defined($telnet)){
     print "E Connection to Host is missing\n";
     print "  Try SetHost() first\n";
     return -1;
 }
 my @result = $telnet->cmd("signalcheck");
 usleep(300000);
 return @result;
}

sub ReadLo($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    
    my @result = $telnet->cmd("bbc_d1");
#    print @result;
    my (@frq, @hexfrq);
    for(my $i=0; $i<@result; $i++){
	next if($result[$i] =~/BNo/);
	if($result[$i] =~/(\s?\d+)\s+([A-F,0-9]+)/){
	    my $ich = $1;
	    $hexfrq[$ich-1] = $2; 
	    $frq[$ich-1] = hex($hexfrq[$ich-1]); 
	}
    }
    $pkg->{hfrq} = \@hexfrq;
    $pkg->{frq} = \@frq;
    return @frq;
}

## Read Baseband LO 
# Check is given, Avoid reading from ADS3000+
sub ReadBLo($;$){
    my $pkg = shift;
    my $Check = shift;
    # Center Local Frequency 
    my @clof = @{$pkg->{frq}};
    my @bw = @{$pkg->{bw}};
    my @ulsb = $pkg->ULSB();
    if($Check){
	@clof = $pkg->ReadLo() unless(defined($clof[0]));
	@bw = $pkg->ReadBW() unless(defined($bw[0]));
	unless(defined($ulsb[0])){
	    $pkg->ReadULSB();
	    @ulsb = $pkg->ULSB();
	}
    }else{
	@clof = $pkg->ReadLo();
	@bw = $pkg->ReadBW(); 
	$pkg->ReadULSB();
	@ulsb = $pkg->ULSB();
    }
    
    my $nch = @clof;
    my $i=0;
    my @blof = @clof;;
    for($i=0; $i<$nch; $i++){
	if( $ulsb[$i] ==0 ) { # USB
	    $blof[$i] = $clof[$i]  - $bw[$i]*0.5;
	}elsif($ulsb[$i] ==1 ){
	    $blof[$i] = $clof[$i]  + $bw[$i]*0.5;
	}
    }
    
    return @blof;

}

sub ReadBW($){
 my $pkg = shift;
 my $telnet = $pkg->{telnet};
 unless(defined($telnet)){
     print "E Connection to Host is missing\n";
     print "  Try SetHost() first\n";
     return -1;
 }
    
 my @result = $telnet->cmd("bbc_bw");
# print @result;
 my (@bwcode, @bw);
 for(my $i=0; $i<@result; $i++){
     next if($result[$i] =~/BNo/);
     if($result[$i] =~/(\s?\d+)[\s\t]+([0-9]+)/){
	 my $ich = $1;
	 $bwcode[$ich-1] = $2; 
	 if($bwcode[$ich-1] == 0){
	     $bw[$ich-1] = 4000000; # Hz
	 }elsif($bwcode[$ich-1] == 1){
	     $bw[$ich-1] = 8000000; # Hz
	 }elsif($bwcode[$ich-1] == 2){
	     $bw[$ich-1] = 16000000; # Hz
	 }elsif($bwcode[$ich-1] == 3){
	     $bw[$ich-1] = 32000000; # Hz
	 }else{
	     print "E bbc_bw return is unexpected\n";
	     return -1;
	 }
     }
 }
 $pkg->{bwcode} = \@bwcode;
 $pkg->{bw} = \@bw;
 return @bw;
}

sub ReadULSB($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
    }
    my @result = $telnet->cmd("dbbcout");
# print @result;
    chomp($result[0]);
    my @ret = split(//,$result[0]);
    if(@ret < 16){
		print "E dbbcout($result[0]) less than expecting 16 \n";
		return -1;
    }
    my @ulsb = @ret;
#     for(my $i=0; $i<@ret; $i++){
# 	if($ret[$i] == 0){ $ulsb[$i] = 0;}
# 	elsif($ret[$i] == 1){ $ulsb[$i] = 1;}
# 	elsif($ret[$i] == 2){ $ulsb[$i] = "Cmplx";}
# 	elsif($ret[$i] == 3){ $ulsb[$i] = "NotUsed";}
#     }
    $pkg->{ulsb} = \@ulsb;
    return 0;
}

sub ReadIFin($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("dbbcin");
# print @result;
    chomp($result[0]);
    my @ifin = split(//, $result[0]);
    if(@ifin < 16){
	print "E dbbcout($result[0]) less than expecting 16 \n";
	return -1;
    }
    $pkg->{ifin} = \@ifin;
    return 0;
}

sub IFin($){
    my $pkg = shift;
    return @{$pkg->{ifin}};
}

sub ULSB($){
    my $pkg = shift;
    return @{$pkg->{ulsb}};
}

sub CompFreq($$){
    my $pkg = shift;
    my $conf = shift;
    
    my $bw = $conf->{bw} * 1.e6;  # MHz -> Hz
    my @frq = @{$conf->{frq}};
    my @ulsb = @{$conf->{ulsb}};
    my $bw2 = 0.5 * $bw;
    my (@hfrq, @cfrq);


    for(my $i=0; $i < @frq; $i++){
	$cfrq[$i] = $frq[$i];
	if($ulsb[$i] ==0){ $cfrq[$i] = $frq[$i] +  $bw2;}
	elsif($ulsb[$i] ==1){ $cfrq[$i] = $frq[$i] - $bw2;}
	else{ $cfrq[$i] = 0;}
	$hfrq[$i] = sprintf("0X%0X",$cfrq[$i]);
    }
    $pkg->{hfrq} = \@hfrq;
    $pkg->{cfrq} = \@cfrq;
    $pkg->{bw} = $bw;
    return @hfrq;
}
## Hexa Center Freq.
sub HexFreq($){
    my $pkg = shift;
    my $hfrq = $pkg->{hfrq};
    return @{$hfrq};
}
sub CFrq($){
    my $pkg = shift;
    return @{$pkg->{cfrq}};
}

sub SetIFin($@){
    my $pkg = shift;
    my @ifarr = @_;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    
    my $cmd1 = join("",@ifarr);
#     for(my $i=0; $i<@ifarr; $i++){
# 	$cmd = sprintf("$cmd%d", $ifarr[$i]);
#     }
    my $cmd = "dbbcin $cmd1";
    print "Ifcmd = $cmd \n";
    $telnet->cmd($cmd);


    return 0;

}

sub SetULSB($@){
   my $pkg = shift;
   my @ulsb = @_;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   
   ########## DBBC Output Setting #########
   
   my $sb= join("",@ulsb);
#    for(my $i=0; $i<@ulsb; $i++){
#        if($ulsb[$i] == -1){ $sb ="${sb}1";}
#        elsif($ulsb[$i] == 1){ $sb ="${sb}0";}
#    }
   $telnet->cmd("dbbcout $sb");
   return 0;
}

sub SetBW($$){
   my $pkg = shift;
   my $bw = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   ########## Band Width Setting #########
   my $ibw = 0;
   if($bw == 4){ $ibw ="0000000000000000";}
    elsif($bw == 8){ $ibw ="1111111111111111";}
   elsif($bw == 16){ $ibw ="2222222222222222";}
   elsif($bw == 32){ $ibw ="3333333333333333";}
   print "BWcmd = bbc_bw -a 1 $ibw\n";
   $telnet->cmd("bbc_bw -a 1 $ibw");
   usleep(3000);
   
   return 0;
}

sub SetLo($){
    my $pkg = shift;
    my @hfrq = @{$pkg->{hfrq}};
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    

    ########## Local Frequency Setting #########
    for(my $i=0; $i<@hfrq; $i++){
	my $cmd = sprintf("bbc_d1 1 %d %s", $i+1,  $hfrq[$i]);
	$telnet->cmd($cmd);
    }

    $telnet->cmd("ncoset");
    
    return 0;
}

sub SetDBBC_Mode($$){
   my $pkg = shift;
   my $mode = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   ########## VSI Mode Setting #########
   if($mode ==0){
       print "VSI-Mode= Div-Bit/Clock-Fix \n";
   }elsif($mode ==1){
       print "VSI-Mode= Div-Bit/Clock-Var \n";
   }if($mode == 2){
       print "VSI-Mode= Div-Ch/Clock-Fix \n";
   }if($mode == 3){
       print "VSI-Mode= Div-Ch/Clock-Var \n";
   }
   if($mode > -1){
       $telnet->cmd("dbbcvsi $mode");       
       usleep(3000);
   }else{
       print "Error: DBBC-mode: $mode is unexpected. Nothing done.\n";
   }
   
   return 0;
}

#miya_add------------------------------------------------
sub SetHost2($$$$){
    my ($pkg,$host,$usr,$pass) = @_;
    unless(defined($host) && defined($usr) && defined($pass)){
	print STDERR "E ADS3kp::SetHost(): missiong some of host,user,pass \n";
	return -1;
    }
    $pkg->{host} = $host; 
# ץץ(ɽ)    
#    my $prompt = '/cosmo login:$|Password:$|\[.+\]\$ $/';
#    my $telnet = new Net::Telnet(Timeout => 10,Prompt => $prompt);
    my $telnet = new Net::Telnet(Timeout => 3, Errmode => "return");
    #$telnet->errmode("return");
	
	my $return = $telnet->open($host);
	unless(defined($return)){return -1;}
	
    $return = $telnet->login($usr, $pass) ;
	unless(defined($return)){return -1;}

    $pkg->{telnet} = $telnet;
    return 0;
}

sub Rev(){
	my $pkg = shift;
	my $telnet = $pkg->{telnet};
	unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
	}
	my @result = $telnet->cmd("rev");
	usleep(300000);
	return @result;
}

sub Version(){
	my $pkg = shift;
	my $telnet = $pkg->{telnet};
	unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
	}
	my @result = $telnet->cmd("version");
	usleep(300000);
	return @result;
}

sub ReadRegs($$){
	my $pkg = shift;
	my $reg = shift;
	my $telnet = $pkg->{telnet};
	my @result= ();
	unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
	}

	if ($reg eq 1){ @result = $telnet->cmd("regs cpu");}
	elsif($reg eq 2){ @result = $telnet->cmd("regs adc");}
	elsif($reg eq 3){ @result = $telnet->cmd("regs fpga1");}
	elsif($reg eq 4){ @result = $telnet->cmd("regs fpga2");}
	elsif($reg eq 5){ @result = $telnet->cmd("regs config");}

	return @result;
}


sub ReadBithist($$){
	my $pkg = shift;
	my $ch = shift;
	my $telnet = $pkg->{telnet};
	my $prompt = '/\n/';
	my @result1= ();
	my @result2= ();
	my $num;
	unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
	}
	@result1=$telnet->print("bit_hist $ch");
	#@result1= $telnet->waitfor($prompt);
    #for(my $i=0; $i<=10; $i++){
    while (1){
		@result1= $telnet->waitfor($prompt);
		$num = @result1;
		if ($num == 0){last;}
		chomp(@result1);# Ժ
		@result1 = grep { $_ ne "" } @result1;# 
		push(@result1,"\n");
		push(@result2,@result1);
	}
	$prompt = '/#/';
	@result1= $telnet->waitfor($prompt);
	
	#my @result3=$telnet->print("\cC");
	#my @result4 = $telnet->waitfor($prompt);
	#my @result4 = $telnet->waitfor($prompt);
	#$prompt = '/\#/';
	#@result4 = $telnet->waitfor($prompt);
	#$prompt = '/\n/';
	#@result4 = $telnet->waitfor($prompt);
	return @result2;
}

sub ReadMode($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("mode");
# print @result;
	for(my $i=0; $i<4; $i++){
		$result[$i] =~ s/[0-9]:\s//g; 
	    chomp($result[$i]);
	}
    return @result;
}

sub ReadOffs($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
    }
    my @result = $telnet->cmd("offs");
    for(my $i=0; $i<@result; $i++){
		$result[$i] =~ s/[0-9]:\s//g; 
	    chomp($result[$i]);
	    
	    $result[$i] = hex($result[$i]);
	}
    return @result;
}

sub ReadGain($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("gain");
# print @result;
	for(my $i=0; $i<@result; $i++){ # miya modify 2015/12/4 4->@result
		$result[$i] =~ s/[0-9]:\s//g; 
	    chomp($result[$i]);
	}
    return @result;
}

sub ReadAdcchsel($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("adcchsel");
# print @result;
	$result[0] =~ s/ADC Channel Selector\s|[.]//g; 
    chomp($result[0]);
    return @result;
}

sub ReadAdcoffs($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("adcoffs");
# print @result;
	$result[0] =~ s/External Offset:\s//g; 
    chomp($result[0]);
    $result[0] = hex($result[0]);
    return @result;
}

sub ReadAdcgain($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("adcgain");
# print @result;
	$result[0] =~ s/External Gain:\s//g; 
    chomp($result[0]);
    $result[0] = hex($result[0]);
    return @result;
}

sub ReadCicgain($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("cicgain");
# print @result;
    chomp($result[0]);
    my @cic = split(//, $result[0]);
    if(@cic < 16){
	print "E dbbcout($result[0]) less than expecting 16 \n";
	return -1;
    }
    $pkg->{cic} = \@cic;
    return @cic;
}

sub ReadBbcgain($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("bbcgain");
# print @result;
    chomp($result[0]);
    my @bbc = split(//, $result[0]);
    if(@bbc < 16){
	print "E dbbcout($result[0]) less than expecting 16 \n";
	return -1;
    }
    $pkg->{bbc} = \@bbc;
    return @bbc;
}

sub ReadVsisel($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("vsisel");
# print @result;
    chomp($result[0]);
    my @vsis = split(//, $result[0]);
    if(@vsis < 8){
	print "E dbbcout($result[0]) less than expecting 8 \n";
	return -1;
    }
    $pkg->{vsis} = \@vsis;
    return @vsis;
}

sub Readsetap($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }

    $telnet->print("setapp");
#    my @result = $telnet->waitfor('/\[.\]:\s/'); #channel mode (1,2,4) [4]: 
    my $line = $telnet->getline(); #channel mode (1,2,4) [4]: 
    print "DBG: $line";
    $telnet->put("\n");
    for(my $i=0; $i<11; $i++){
#	my @out = $telnet->waitfor('/\[.\]:\s/'); 
	my $out = $telnet->getline(); #channel mode (1,2,4) [4]: 
#	print "DBG:", $out;
	$telnet->put("\n");
   }
   $telnet->cmd("\n");
   #print @result;
#    return @result;
    return $line;
}

sub ReadLSB($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("dbbcout");
# print @result;
    chomp($result[0]);
    my @lsb = split(//,$result[0]);
    if(@lsb < 16){
	print "E dbbcout($result[0]) less than expecting 16 \n";
	return -1;
    }
    $pkg->{lsb} = \@lsb;
    return @lsb;
}
 
sub ReadFin($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    my @result = $telnet->cmd("dbbcin");
# print @result;
    chomp($result[0]);
    my @fin = split(//, $result[0]);
    if(@fin < 16){
	print "E dbbcout($result[0]) less than expecting 16 \n";
	return -1;
    }
    $pkg->{fin} = \@fin;
    return @fin;
}

sub ReadDbbcvsi($){
    my $pkg = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    #my $result = $telnet->cmd("dbbcvsi");
    my @result = $telnet->cmd("dbbcvsi");
#    chomp($result[0]);
#    my @vsi = split(//,$result[0]);
#    if(@vsi < 1){
#	print "E dbbcout($result[0]) less than expecting 1 \n";
#	return -1;
#    }
#    $pkg->{vsi} = \@vsi;
#    return @vsi;
    return @result;
}

sub Set1pps($){
   my $pkg = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("1pps_sync");
   return 0;
}

sub SetMode($$$){
   my $pkg = shift;
   my $ch = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("mode $ch $num");
   return 0;
}

sub SetOffs($$$){
   my $pkg = shift;
   my $ch = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("offs $ch $num");
   return 0;
}

sub SetGain($$$){
   my $pkg = shift;
   my $ch = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("gain $ch $num");
   return 0;
}

sub SetPdata($){
   my $pkg = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("pdata_on");
   return 0;
}

sub SetCicgain($@){
    my $pkg = shift;
    my @cicarr = @_;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    
    my $cmd1 = join("",@cicarr);
#     for(my $i=0; $i<@cicarr; $i++){
# 	$cmd = sprintf("$cmd%d", $cicarr[$i]);
#     }
    my $cmd = "cicgain $cmd1";
    print "Ifcmd = $cmd \n";
    $telnet->cmd($cmd);
    return 0;
}

sub SetBbcgain($@){
    my $pkg = shift;
    my @bbcarr = @_;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
	print "E Connection to Host is missing\n";
	print "  Try SetHost() first\n";
	return -1;
    }
    
    my $cmd1 = join("",@bbcarr);
#     for(my $i=0; $i<@bbcarr; $i++){
# 	$cmd = sprintf("$cmd%d", $bbcarr[$i]);
#     }
    my $cmd = "bbcgain $cmd1";
    print "Ifcmd = $cmd \n";
    $telnet->cmd($cmd);
    return 0;
}

sub SetVsi($$){
   my $pkg = shift;
   my $ivsi = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   print "dbbcvsi = dbbcvsi $ivsi\n";
   $telnet->cmd("dbbcvsi $ivsi");
   usleep(3000);
   
   return 0;
}

sub Setvsisel($){
   my $pkg = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("vsisel 2 0");
   $telnet->cmd("vsisel 1 0");
   usleep(3000);
   
   return 0;
}

sub SetAdcchsel($$){
   my $pkg = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("adcchsel $num");
   return 0;
}

sub SetAdcoffs($$){
   my $pkg = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("adcoffs $num");
   return 0;
}

sub SetAdcgain($$){
   my $pkg = shift;
   my $num = shift;
   my $telnet = $pkg->{telnet};
   unless(defined($telnet)){
       print "E Connection to Host is missing\n";
       print "  Try SetHost() first\n";
       return -1;
   }
   $telnet->cmd("adcgain $num");
   return 0;
}

sub Setsetap($$){
    my $pkg = shift;
    my $isetap = shift;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
    }

   $telnet->print("setapp");
   my @result = $telnet->waitfor('/\[.\]:\s/'); #channel mode (1,2,4) [4]: 
   $telnet->put(" $isetap\n");
   print "setapp = $isetap\n";
   for(my $i=0; $i<11; $i++){
#	my @out = $telnet->waitfor('/\[.\]:\s/'); 
	$telnet->put("\n");
   }
   $telnet->cmd("\n");
	return 0;
	
}

sub SetLo_2($@){
    my $pkg = shift;
    my @hfrq = @_;
    my $telnet = $pkg->{telnet};
    unless(defined($telnet)){
		print "E Connection to Host is missing\n";
		print "  Try SetHost() first\n";
		return -1;
    }
    
    ########## Local Frequency Setting #########
    my $ii=0;
    for(my $i=0; $i<@hfrq; $i++){
		my $cmd = sprintf("bbc_d1 1 %d %s", $i+1,  $hfrq[$i]);
		$ii=$i+1;
		print "bbc_d1 = bbc_d1 1 $ii $hfrq[$i]\n";
		$telnet->cmd($cmd);
    }

    $telnet->cmd("ncoset");
    
    return 0;
}

1;

