#include <cstdlib>
#include <math.h>
#include <iostream>
#include <fstream>
#include  <vector>
#include "gaussian_fitting.hpp"

using namespace std;

void Usage(){
  cout<<"Calculate power from  histogram"<<endl;
  cout<<"arg1: input filename"<<endl;
  exit(0);
}

int main(int argc, char** argv){
  if (argc ==1 ) { Usage () ; exit(0); }
  ifstream fop(argv[1]);

  vector<double> data;

  double tmp;
  while(fop>>tmp){
    if(tmp!=0.0)    data.push_back(log(tmp));
    if(tmp==0.0)    data.push_back(tmp);
  }
  cout<<"data size "<<data.size()<<endl;
  double* x = new double[data.size()];
  double* y = new double[data.size()];
  for(uint i=0 ; i<data.size() ; i++){
    x[i] = i;
    y[i] = data[i];
  }
  double var,ave, amp;
  gaussian_fitting(x, y,data.size(),  var, ave, amp);
  cout<<"var:"<<var<<" ave:"<<(ave) << " Amp:" << amp << endl;

   delete [] x;
   delete [] y;
}//main


