#!/usr/bin/perl -w

sub usage(){
    print "Usage: $0 <infput file> \n";
    print "Testing gaussian fitting program gauss_fit.\n";
    exit(1);
}


my $cmd = "gauss-fit";

use Math::Trig;
sub gauss($$$$){
    my ($x, $sig2, $mu,$amp) = @_;
    my $nx = ($x-$mu);
    my $y = -0.5 * $nx*$nx/$sig2;
#    my $ret = 1./sqrt(2.0 * pi)/$sig * exp($y);;
    my $ret =  $amp * exp($y);;
    return $ret;
}

{

    usage() if(@ARGV < 1);
    my $infile = shift;
    open(IN,$infile) || die "Cannot open infile ($infile) \n";
    @dat = <IN>;
    close(IN);
    use lib "$ENV{HOME}/prog/perl/module";
    use pltutl;
    use PGPLOT;
    my @x;
    for(my $i=0; $i<@dat; $i++){
	$x[$i] = $i;
    }
    
    my $pltinf = new Pltutl;
    $pltinf->Set_symbol(4);
    pgopen("/xw");
#    pgopen("?");
    
    $pltinf->Plot1d(\@x, \@dat);
    my $cmd1 ="$cmd $infile";
    open(PIP,  "$cmd1 |") || die "Cannot open $cmd\n";
    my @ret = <PIP>;
    print "ret = @ret\n";
    $ret[1] =~/var:\s+(\S+)\s+ave:\s*(\S+)\s*Amp:(\S+)/;
    my $sig2 = $1;
    my $mu = $2;
    my $amp = $3;
    
    my $npt = 100;
    my $stp = $x[$#x]/$npt;
    my (@x2, @y2);
    for(my $i=0; $i< $npt; $i++){
	$x2[$i] = $i * $stp;
	$y2[$i] = gauss($i * $stp, $sig2, $mu, $amp);
    }
    $pltinf->Set_line(2);
    $pltinf->Oplot1d(\@x2, \@y2);
    

    pgclos();
}
